package sun.security.provider.certpath;

import java.security.cert.CRL;
import java.security.cert.CRLSelector;
import java.util.Iterator;
import java.security.cert.CertStoreException;
import java.util.ConcurrentModificationException;
import java.util.HashSet;
import java.security.cert.Certificate;
import java.security.cert.CertSelector;
import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CollectionCertStoreParameters;
import java.security.cert.CertStoreParameters;
import java.util.Collection;
import java.security.cert.CertStoreSpi;

public class CollectionCertStore extends CertStoreSpi
{
    private Collection<?> coll;
    
    public CollectionCertStore(CertStoreParameters params) throws InvalidAlgorithmParameterException {
        super(params);
        if (!(params instanceof CollectionCertStoreParameters)) {
            throw new InvalidAlgorithmParameterException("parameters must be CollectionCertStoreParameters");
        }
        this.coll = ((CollectionCertStoreParameters)params).getCollection();
        return;
    }
    
    @Override
    public Collection<Certificate> engineGetCertificates(CertSelector certSelector) throws CertStoreException {
        if (this.coll == null) {
            throw new CertStoreException("Collection is null");
        }
        int i = 0;
        while (i < 10) {
            try {
                HashSet o = new HashSet();
                if (certSelector != null) {
                    for (Object next2 : this.coll) {
                        if (next2 instanceof Certificate && certSelector.match((Certificate)next2)) {
                            o.add((Certificate)next2);
                        }
                        else {
                            continue;
                        }
                    }
                    return o;
                }
                for (Object next : this.coll) {
                    if ((next instanceof Certificate)) {
                        o.add((Certificate)next);
                    }
                    else {
                        continue;
                    }
                }
                return o;
            }
            catch (ConcurrentModificationException ex) {
                ++i;
            }
        }
        throw new ConcurrentModificationException("Too many ConcurrentModificationExceptions");
    }
    
    @Override
    public Collection<CRL> engineGetCRLs(CRLSelector crlSelector) throws CertStoreException {
        if (this.coll == null) {
            throw new CertStoreException("Collection is null");
        }
        int i = 0;
        while (i < 10) {
            try {
                HashSet o = new HashSet();
                if (crlSelector != null) {
                    for (Object next2 : this.coll) {
                        if (next2 instanceof CRL && crlSelector.match((CRL)next2)) {
                            o.add((CRL)next2);
                        }
                        else {
                            continue;
                        }
                    }
                    return o;
                }
                for (Object next : this.coll) {
                    if ((next instanceof CRL)) {
                        o.add((CRL)next);
                    }
                    else {
                        continue;
                    }
                }
                return o;
            }
            catch (ConcurrentModificationException ex) {
                ++i;
            }
        }
        throw new ConcurrentModificationException("Too many ConcurrentModificationExceptions");
    }
}
